/**
 * Main startup functions

 * Copyright (C) 2003  Shawn Betts
 * Copyright (C) 2003  Sylvain Beucler
 * Copyright (C) 2003  Andrew McCall
 * Copyright (C) 2003  Andrew Reading
 * Portions Copyright (C) Seth A. Robinson, 1997-2003

 * This file is part of GNU FreeDink

 * GNU FreeDink is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.

 * GNU FreeDink is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with program; see the file COPYING. If not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.

 * $Header: /cvsroot/dink/dink/src/dink.cpp,v 1.3 2003/12/01 22:47:26 Beuc Exp $
 */

#include <getopt.h>
#include "dink.h"

// Not in constants.h so it does not conflict with Dinkedit's
#define NAME	"Dink Smallwood"
#define TITLE	"Dink Smallwood"

int fps_average;


void move (int u, int amount, char kind, char kindy);
void draw_box (rect box, int color);
void run_through_tag_list_push (int h);
void random_blood (int mx, int my, int h);
int check_if_move_is_legal (int u);
void change_dir_to_diag (int *dir);
int hurt_thing (int h, int damage, int special);

int but_timer;
int water_timer;
bool fire_forward;
int fire_flip;

int fps_show = 0;
BOOL InitSound ();
BOOL DestroySound (void);
BOOL DSDisable (void);
BOOL DSEnable ();

int drawthistime = true;
int x = 640;
int y = 480;
rect rc;
int winoffset = 25;
int winoffsetx = 5;
int cx;
int cy;
int speed;

char *g_fontdir = NULL;
player_short_info short_play;

Mix_Music *music_data = NULL;
bool g_b_no_write_ini = false;
bool no_cheat = true;
int last_saved_game = 0;
bool g_b_kill_app = false;	//if true, will close app as soon as the message pump is
int dinkspeed = 3;
int last_cd;
char current_map[255] = "map.dat";
int regcode, mycode;
time_t time_start;
bool item_screen = false;
bool midi_active = true;
char dversion_string[] = VERSION;
char dinkpath[200];
UINT CD_ID;
int map_vision = 0;
int flub_mode = -500;
unsigned short decipher_savegame = 0;
int draw_map_tiny = -1;

char last_debug[200];
int walk_off_screen = false;

bool cd_inserted;
int burn_revision = 0;
bool abort_this_flip = false;
show_bmp_t showb;
int keep_mouse = 0;
int mcc, sound_support;
attackinfo_struct bow;
soundstruct soundinfo[num_soundbanks + 1];
int screenlock = 0;
talk_struct talk;
char last_midi[15];
char midi_cur[20];
char midi_last[20];
int *pvision, *plife, *presult, *pspeed, *ptiming, *plifemax, *pexper, *pmap,
  *pstrength, *pcur_weapon, *pcur_magic, *pdefense, *pgold, *pmagic, *plevel,
  *plast_text, *pmagic_level;
int *pupdate_status, *pmissile_target, *penemy_sprite, *pmagic_cost,
  *pmissle_source;
int flife, fexp, fstrength, fdefense, fgold, fmagic, fmagic_level, flifemax,
  fraise, last_magic_draw;
int fcur_weapon, fcur_magic;
int mbase_timing;
idata id[max_idata];

DWORD mold;

int item_timer;
int item_pic;

int mbase_count;
bool no_transition = false;
seth_sound ssound[max_sounds];

int push_active = 1;

bool turn_on_plane = FALSE;
TTF_Font *lf = NULL;
TTF_Font *hfont = NULL;
TTF_Font *hfont_small = NULL;
int stop_entire_game;
bool in_enabled = false;
char *in_string;
bool first_frame = false;
bool no_running_main = false;
call_back callback[max_callbacks];
char *rbuf[max_sprites];	//pointers to buffers we may need
refinfo *rinfo[max_sprites];
int process_warp = 0;
bool process_upcycle = false;
bool process_downcycle = false;
DWORD cycle_clock = 0;
int cycle_script = 0;
int *in_int;
int in_x, in_y;
int sp_brain = 0;
int returnint = 0;
char returnstring[200];
int sp_speed = 0;
char slist[10][200];
long nlist[10];
int process_count = 0;
rect sp_alt;
int hard_tile = 0;
bool sp_screenmatch = 0;
char in_temp[200];
int in_command;
int in_finish;
int in_onflag;
int in_max = 10;
int in_huh = 0;
char in_default[200];
int in_master = 0;
bool sound_on = true;
char dir[80];
bool please_wait = false;
int show_dot = FALSE;
int plane_process = TRUE;
hit_map hm;

sprite_index *sequence_index;
int last_sprite_added = 0;
DWORD timer = 0;
char *command_line;
bool dinkedit = false;
int base_timing;
int weapon_script = 0;
int magic_script = 0;

int sp_mode = 0;
int fps, fps_final = 0;
int last_sprite_created;
int move_screen = 0;
bool move_gonna = false;
int move_counter = 0;
int m1x, m1y;
int m2x, m2y;
int m3x, m3y;
int playx = 620;
bool windowed = false;
int playl = 20;

bool mouse1 = false;
int cur_sprite = 1;
int playy = 399;
int cur_map, cur_tile;
seth_joy sjoy;
DWORD thisTickCount, lastTickCount;
DWORD timecrap;
rect math, box_crap, box_real;

int sz, sy, x_offset, y_offset;

wait_for_button_t wait;

int mode;

sequence *seq;
map_info map;
small_map pam;

//SDL_Surface *     lpDDSOne;       // Offscreen surface 1
SDL_Surface *lpDDSTwo = NULL;	// Offscreen surface 2
SDL_Surface *lpDDSTrick = NULL;	// Offscreen surface 2
SDL_Surface *lpDDSTrick2 = NULL;	// Offscreen surface 2
bool trig_man = false;
bool total_trigger = false;
bool debug_mode = false;

pic_info *k;			// Sprite data
player_info play;


SDL_Surface *lpDDSPrimary = NULL;	// DirectDraw primary surface
SDL_Surface *lpDDSBack = NULL;	// DirectDraw back surface

SDL_Surface *tiles[tile_screens];	// Game pieces
SDL_Surface *game[max_game];	// Game pieces

sp *spr;			//max sprite control systems at once

SDL_Color pe[256];
SDL_Color real_pal[256];

BOOL bActive = false;		// is application active?

BYTE torusColors[256];		// Marks the colors used in the torus

SDL_Joystick *jinfo;
BOOL joystick = false;
hardness hmap;
rect tilerect[tile_screens];


bool
initFail (char mess[200])
{
  fprintf (stderr, mess);
  finiObjects ();
  return false;
}

/**
 * Prints the version on the standard ouput. Based on the homonymous
 * function from ratpoison
 */
void
print_version ()
{
  printf ("GNU %s %s\n", PACKAGE, VERSION);
  printf ("Copyright (C) 1997, 2003 by contributors\n");
  printf ("GNU %s comes with ABSOLUTELY NO WARRANTY.\n", PACKAGE);
  printf ("You may redistribute copies of FreeDink\n");
  printf ("under the terms of the GNU General Public License.\n");
  printf ("For more information about these matters, see the file named COPYING.\n");
  exit (EXIT_SUCCESS);
}

/**
 * Prints the version on the standard ouput. Based on the homonymous
 * function from ratpoison
 */
void
print_help ()
{
  printf ("Help for %s %s\n\n", PACKAGE, VERSION);
  printf ("TODO                  Display the default configuration here\n");
  printf ("-h, --help            Display this help screen\n");
  printf ("-v, --version         Display the version\n");
  printf ("\n");
  printf ("-g, --game <dir>      Specify a DMod directory\n");
  printf ("-f, --fontdir <dir>   Specify an alternative font directory\n");
  printf ("\n");
  printf ("-d, --debug           Explain what is being done\n");
  printf ("-i, --noini           Do not attempt to write dinksmallwood.ini\n");
  printf ("-j, --nojoy           Do not attempt to use joystick\n");
  printf ("-s, --nosound         Do not play sound\n");
  printf ("-w, --window          Use windowed mode instead of screen mode\n");
  printf ("\n");

  printf ("Report bugs to TODO %s\n", PACKAGE_BUGREPORT);
  printf ("Type 'info freedink' for more information\n");

  exit (EXIT_SUCCESS);
}

/**
 * Check the command line arguments and initialize the required global
 * variables
 */
bool
check_arg (int argc, char *argv[])
{
  int i;
  int c;

  strcpy (dir, "dink");
  g_fontdir = (char *) strdup ("../fonts/");

  /** Options '-debug', '-game', '-noini', '-nojoy', '-nosound' and
      '-window' are required to maintain backward compatibility with
      the original non-free Dink */
  struct option long_options[] = 
    {
      {"debug",   no_argument,       NULL, 'd'},
      {"fontdir", required_argument, NULL, 'f'},
      {"game",    required_argument, NULL, 'g'},
      {"help",    no_argument,       NULL, 'h'},
      {"noini",   no_argument,       NULL, 'i'},
      {"nojoy",   no_argument,       NULL, 'j'},
      {"nosound", no_argument,       NULL, 's'},
      {"version", no_argument,       NULL, 'v'},
      {"window",  no_argument,       NULL, 'w'},
      {0, 0, 0, 0}
    };
  
  char short_options[] = "df:g:hijsvw";


  // Loop through each argument
  while ((c = getopt_long_only (argc, argv, short_options, long_options, NULL)) != EOF)
    {
      switch (c) {
      case 'd':
	  debug_mode = true;
	  unlink ("dink/debug.txt");
	  break;
      case 'f':
	char tmp[256], olddir[256];
	free (g_fontdir);
	
	g_fontdir = optarg;
	
	// Get the absolute path of the font directory. This
	// must be done because dink changes the cwd to the game
	// dir and a relative path the fonts may no longer work.
	dink_getcwd (olddir, 255);
	if (dink_chdir (g_fontdir) == -1)
	  {
	    Msg (("Unable to find font dir, %s.", g_fontdir));
	    exit(EXIT_FAILURE);
	  }
	dink_getcwd (tmp, 254);
	// Add a frontslash if there isn't one
	if (tmp[strlen (tmp) - 1] != '/')
	  {
	    int len = strlen (tmp);
	    
	    tmp[len] = '/';
	    tmp[len + 1] = '\0';
	  }
	
	// free (g_fontdir);
	g_fontdir = strdup (tmp);
	dink_chdir (olddir);
	
	Msg (("Fontdir is now %s.", g_fontdir));
	
	break;
      case 'g':
	// The next argument is the game directory, make sure this
	// isn't the last argument.
	strcpy (dir, optarg);
	Msg (("Working directory %s requested.", dir));
	break;
      case 'h':
	print_help();
	break;
      case 'j':
	joystick = false;
	break;
      case 'i':
	g_b_no_write_ini = true;
	break;
      case 's':
	sound_on = false;
	break;
      case 'v':
	print_version();
	break;
      case 'w':
	  windowed = true;
	  no_transition = true;
	  break;	
      default:
	exit (EXIT_FAILURE);
      }
    }

  if (dink_chdir (dir) == -1)
    {
      char shit[200];
      
#ifdef __ENGLISH
      sprintf (shit, "Game dir \"%s\" not found!\n", dir);
#endif
#ifdef __GERMAN

      sprintf (shit, "Spiele-direktory \"%s\" nicht gefunden!\n", dir);
#endif
      
      initFail (shit);
      return false;
    }
  
  Msg (("Dir is now %s.", dir));
  return true;
}

bool
initfonts (char fontname[255])
{
  char *fullpath;

  fullpath =
    (char *) malloc ((strlen (fontname) + strlen (g_fontdir) + 1) *
		     sizeof (char *));

  strcpy (fullpath, g_fontdir);
  strcat (fullpath, fontname);

  lf = TTF_OpenFont (fullpath, 16);
  hfont = TTF_OpenFont (fullpath, 16);
  hfont_small = TTF_OpenFont (fullpath, 16);

  if (lf == NULL || hfont == NULL || hfont_small == NULL)
    {
      Msg (("TTF_OpenFont: %s", TTF_GetError ()));
      return false;
    }

  free (fullpath);

  return true;
}

void
kill_fonts ()
{
  TTF_CloseFont (lf);
  TTF_CloseFont (hfont);
  TTF_CloseFont (hfont_small);

}


/**
 * ? Clean-up
 */
void
finiObjects ()
{
  kill_all_scripts_for_real ();
  FastFileFini ();
  g_b_kill_app = true;
}

void
load_batch (void)
{
  FILE *stream;
  char line[255];

  spr[1].x = 200;
  spr[1].y = 300;


  Msg (("Loading .ini"));
  if (!exist ("dink.ini"))
    {
      Msg (("File not found."));

      sprintf (line, "Error finding the dink.ini file in the %s dir.", dir);
      Msg ((line));
//              TRACE(line);

    }


  if ((stream = fopen ("dink.ini", "r")) != NULL)
    {

      while (1)
	{
	  if (fgets (line, 255, stream) == NULL)
	    goto done;
	  else
	    {
	      pre_figure_out (line, 0);
	    }

	}

    done:
      fclose (stream);
    }
  else
    {
//              TRACE("Dink.ini missing.");
      Msg (("Dink.ini missing."));
    }

  program_idata ();

}

/*
* finiObjects
*
* finished with all objects we use; release them
*/
// long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
//                                                 WPARAM wParam, LPARAM lParam )
// {
//      switch( message )
//      {
//      case WM_ACTIVATEAPP:
//              bActive = wParam;
//              break;

//      case WM_SETCURSOR:
//              SetCursor(NULL);
//              return TRUE;

//      case WM_CREATE:
//              break;
//      case WM_IMDONE:
//              Msg(("Sending quit message."));
//              PostQuitMessage(0);
//              break;

//      }

//      program_idata();

// }
#include <sys/types.h>
#include <sys/stat.h>

bool
random_date (char file[255])
{
// MERLIN: I found this comment incredibly funny so I left it.  
//      let's randomize the date on this file to trick Windows
//      cacheing into doing it right!
// SABETTS: let's not.
  return true;
}

int
dir_num (char path[255])
{
  // SABETTS: please the one caller
  return 250 + 9;
}

void
load_tilescreens ()
{
  char crap[30];
//UNREFERENCED   char crap1[10];

  Msg (("loading tilescreens..."));
  int h;

  for (h = 1; h < tile_screens; h++)
    {
      //                if (h < 10) strcpy(crap1,"0"); else strcpy(crap1, "");
      sprintf (crap, "tiles/ts%02d.bmp", h);

      if (!exist (crap))
	{
	  sprintf (crap, "../dink/tiles/ts%02d.bmp", h);
	}

      //                tiles[h] = DDTileLoad(lpDD, crap, 0, 0,h); 
      tiles[h] = load_image (crap, false, 0, 0, 0);

      if (tiles[h] == NULL)
	{
	  printf ("failed on %s\n", crap);
	  initFail ("Couldn't find one of the tilescreens!");
	}
      else
	{
	  tilerect[h].left = 0;
	  tilerect[h].top = 0;
	  tilerect[h].bottom = tiles[h]->h;
	  tilerect[h].right = tiles[h]->w;
//          SDL_SetColorKey (tiles[h], SDL_SRCCOLORKEY, 
//           SDL_MapRGB (lpDDSBack->format, 0, 0, 0));
	}
    }
  Msg (("Done with tilescreens..."));
}

void
load_splash ()
{
  Msg (("Loading splash"));
  if (exist ("tiles/splash.bmp"))
    lpDDSTrick = load_image ("tiles/splash.bmp", false, 0, 0, 0);
  else
    lpDDSTrick = load_image ("../dink/tiles/splash.bmp", false, 0, 0, 0);

  if (exist ("tiles/splash.bmp"))
    lpDDSTrick2 = load_image ("tiles/splash.bmp", false, 0, 0, 0);
  else
    lpDDSTrick2 = load_image ("../dink/tiles/splash.bmp", false, 0, 0, 0);
}


void
display_loading_screen ()
{
  if (exist ("tiles/splash.bmp"))
    lpDDSTwo = load_image ("tiles/splash.bmp", false, 0, 0, 0);
  else
    lpDDSTwo = load_image ("../dink/tiles/splash.bmp", false, 0, 0, 0);

  SDL_BlitSurface (lpDDSTwo, NULL, lpDDSPrimary, NULL);

//   SDL_BlitSurface (lpDDSBack, NULL, lpDDSPrimary, NULL);
//   SDL_UpdateRect (lpDDSPrimary, 0, 0, 0, 0);
  flip_it ();
}

static bool
doInit ()
{
  SDL_Rect rcRect;
//UNREFERENCED   SDL_Rect rcRectSrc;
//UNREFERENCED   SDL_Rect rcRectDest;

  init_sprites ();

	if (!init_video ())
    {
      return false;
    }
//   init_audio();
  init_mouse_status (&mouse_status);
  memset (&hm, 0, sizeof (hit_map));
  load_tilescreens ();

  if (sound_on)
    {
      Msg (("Initting sound"));
      sound_on = InitSound ();
    }
  srand ((unsigned) time (NULL));

  getCDTrackStartTimes ();

  if (cd_inserted)
    PlayCD (7);


  joystick = CheckJoyStickPresent ();

  rcRect.x = 0;
  rcRect.y = 0;
  rcRect.w = x;
  rcRect.h = y;

  display_loading_screen ();
  Msg(("Finished loading screen"));

  //dinks normal walk

  Msg (("loading batch"));
  load_batch ();
  Msg (("done loading batch"));

  load_hard ();

  //Activate dink, but don't really turn him on
  //spr[1].active = true;
  spr[1].timer = 33;

  //copy from player info
  spr[1].x = play.x;
  spr[1].y = play.y;

  load_splash ();

  last_sprite_created = 1;
  mode = 0;
  load_info ();

  for (int u = 1; u <= 10; u++)
    play.button[u] = u;


  for (int x1 = 1; x1 <= 10; x1++)
    {
      sjoy.letgo[x1] = true;
    }

  //lets run our init script

  int script = load_script ("main", 0, true);

  locate (script, "main");
  run_script (script);
  //lets attach our vars to the scripts

  attach ();

  //init_mouse(hwnd);

  if (!initfonts ("default.ttf"))
    {
      return false;
    }
  //g_pMouse->Acquire();

  return true;
}

static void
gather_events ()
{
  SDL_Event event;

  while (SDL_PollEvent (&event))
    {
      switch (event.type)
	{
	case SDL_MOUSEBUTTONDOWN:
	  {
	    Msg (("mouse down"));
	    mouse_status.button = true;
	  }
	  break;
	case SDL_MOUSEBUTTONUP:
	  {
	    Msg (("mouse up"));
	    mouse_status.button = false;
	  }
	  break;
	case SDL_MOUSEMOTION:
	  {
	    mouse_status.x = event.motion.x;
	    mouse_status.y = event.motion.y;
	  }
	  break;
	case SDL_ACTIVEEVENT:
	  {
//          Msg (("active event"));
	    if (event.active.state & SDL_APPACTIVE)
	      {
		if (event.active.gain)
		  {
//              bActive = true;
		  }
		else
		  {
//              bActive = false;
		  }
	      }
	  }
	  break;

	case SDL_QUIT:
	  {
	    printf ("Quit requested, quitting.\n");
	    exit (0);
	  }
	  break;
	}
    }
}

int
main (int argc, char *argv[])
{
  // Read the command line arguments
  if (!check_arg (argc, argv))
    {
      return 1;
    }

  if (!doInit ())
    {
      Msg (("Init failed\n"));
      return 1;
    }

//  log_path (true);
  bActive = true;

  while (g_b_kill_app == false)
    {
      gather_events ();
      if (bActive)
	{
	  updateFrame ();
	}
    }

  return 0;
}

